=begin
/****************************************************************************
This is library for kredit.rb
by Nobuyuki Horie

*****************************************************************************/
=end

require "kde"
include Kde
require "kconv"

ID_Message = 1
ID_Pos = 2

class REditWindow < KEdit
def initialize kapp, parent, name
   #mypalette = QPalette.new(QColor("white"))
   #setPalette(mypalette)
   #setBackgroundColor(QColor("white"))
   @ksc = KSpellConfig.new
   Qt::connect(self,QSIGNAL("CursorPositionChanged()"),self,"showCursorPosition")
   catchEvent
end
def ksConfig
   @ksc
end
def setKSConfig  ksc
   @ksc = ksc
end

def setPopup popup
   @popup = popup
end

def spellcheck
   @krspell = KRSpell.new(self, "KREdit: Spellcheck", self, "spellcheck2")
   @kspell = @krspell.getKSpell;
end
def spellcheck2 kspell
   @krspell.spellcheck
end

def mousePressEvent(  event )
  if( event.button == RightButton )
	@popup.execQPoint( QCursor::pos )
  end
end

#def mouseReleaseEvent( event )
#    showCursorPosition
#end

def setStatusBar sb
    @sBar = sb
end

def keyReleaseEvent( event )
#    showCursorPosition
    @sBar.changeItem("",ID_Message)
end

def showCursorPosition
#      ar = getCursorPosition()
      l = currentLine + 1
      c = currentColumn + 1
      @sBar.changeItem("line:#{l}:col:#{c}",ID_Pos)
end
end

class REditorWindow < KTMainWindow
    NewDoc = 1
    Open = 2
    Save = 3
    Print = 4
    Close = 5
    ToggleMenuBar = 6
    ToggleToolBar = 7
    ToggleStatusBar = 8
    MARGIN = 20
    Cut = 11
    Copy = 12
    Paste = 13
    SelectAll =14
    SaveAs = 15
    About = 16
    AboutQt = 17
    Quit = 18
    SetForegroundColor = 19
    SetBackgroundColor = 20
    Spellcheck = 21
    SpellcheckConfig = 22
    Search = 23
    SearchAgain = 24
    Replace = 25
    GoToLine = 26
    SetFixedFont = 27
    SetFont = 28


def initialize
    super 0, "example application main window"
    @fileOpenText = i18n("Click this button to open a new file.\n\nYou can also select the Open command from the File menu.")
    @fileSaveText = i18n("Click this button to save the file you are editing.  You will be prompted for a file name.\n\nYou can also select the Save command from the File menu.\n\nNote that implementing this function is left as an exercise for the reader.")
    @filePrintText = i18n("Click this button to print the file you are editing.\n\nYou can also select the Print command from the File menu.")

    @printer = QPrinter.new
    @printer.setMinMax( 1, 10 );
    kl = KIconLoader.new
    @newIcon = kl.loadIcon(QString.new("filenew.xpm"))
    @openIcon = kl.loadIcon(QString.new("fileopen.xpm"))
    @saveIcon = kl.loadIcon(QString.new("filefloppy.xpm"))
    @printIcon = kl.loadIcon(QString.new("fileprint.xpm"))
    @copyIcon = kl.loadIcon(QString.new("editcopy.xpm"))
    @copyCut = kl.loadIcon(QString.new("editcut.xpm"))
    @copyPaste = kl.loadIcon(QString.new("editpaste.xpm"))

    @fileTools = KToolBar.new( self, "file operations" )
    addToolBar(@fileTools)

    @fileTools.insertButton( @newIcon, NewDoc,true,i18n("New &window"))

    @fileTools.insertButton( @openIcon, Open,true,i18n("&Open"))

    @fileTools.insertButton( @saveIcon, Save,true,i18n("&Save"))

    @fileTools.insertButton( @printIcon, Print,true,i18n("&Print"))
    @fileTools.insertSeparator

    @fileTools.insertButton( @copyIcon, Copy,true,i18n("&Copy"))
    @fileTools.insertButton( @copyCut, Cut,true,i18n("&Cut"))
    @fileTools.insertButton( @copyPaste, Paste,true,i18n("&Paste"))

    @fileTools.insertSeparator
    @fileTools.insertSeparator
    @fileTools.insertButton( kl.loadIcon(QString.new("exit.xpm")),Quit,true,i18n("&Quit"))
    @fileTools.insertSeparator
    @whatsThisButton = QWhatsThis.whatsThisButton(@fileTools)
    @fileTools.insertWidget(999,@whatsThisButton.sizeHint.width,@whatsThisButton)
    QWhatsThis::add( @fileTools.getWidget(Open), @fileOpenText, false )
    QWhatsThis::add( @fileTools.getWidget(Save), @fileSaveText, false )
    QWhatsThis::add( @fileTools.getWidget(Print), @filePrintText, false )
    Qt::connect(@fileTools,QSIGNAL("clicked(int)"),self,"menuActivated")

    @file = QPopupMenu.new
#    @menuBar = self.menuBar
    menuBar.insertItem( i18n("&File"), @file )
    Qt::connect(menuBar,QSIGNAL("activated(int)"),self,"menuActivated")

#    @file.insertItem( "New", self, "newDoc", Qt::CTRL+Key_N );
    @file.insertItem(i18n("New window"),NewDoc,-1)
    @file.setAccel(Qt::CTRL+Key_N,NewDoc)

#    @file.insertItem( openIcon, "Open", self, SLOT(load()), CTRL+Key_O );
    @file.insertItemQPixmapTextId(@openIcon,i18n("Open"),Open,-1)
    @file.setAccel(Qt::CTRL+Key_O,Open)

#    @file.insertItemQPixmapTextId( saveIcon, "Save", this, SLOT(save()), CTRL+Key_S );
    @file.insertItemQPixmapTextId(@saveIcon,i18n("Save"),Save,-1)
    @file.setAccel(Qt::CTRL+Key_S,Save)

    @file.insertItemQPixmapTextId(@saveIcon,i18n("Save As"),SaveAs,-1)
    @file.setAccel(Qt::CTRL+Key_A,SaveAs)

    @file.insertSeparator

#    file->insertItem( printIcon, "Print", this, SLOT(print()), CTRL+Key_P );
    @file.insertItemQPixmapTextId(@printIcon,i18n("Print"),Print,-1)
    @file.setAccel(Qt::CTRL+Key_P,Print)

    @file.insertSeparator

#    file->insertItem( "Close", this, SLOT(closeDoc()), CTRL+Key_W );
    @file.insertItem(i18n("Close"),Close,-1)
    @file.setAccel(Qt::CTRL+Key_W,Close)

#    file->insertItem( "Quit", qApp, SLOT(quit()), CTRL+Key_Q );

    @file.insertItemQObj(i18n("Quit"),QApplication::qApp,QSLOT("quit()"),Qt::CTRL+Key_Q)

    @edit = QPopupMenu.new

    menuBar.insertItem(i18n( "&Edit"), @edit )
    @edit.insertItem(i18n("&Copy"),Copy,-1)
    @edit.setAccel(Qt::CTRL+Key_C,Copy)

    @edit.insertItem(i18n("C&ut"),Cut,-1)
    @edit.setAccel(Qt::CTRL+Key_U,Cut)

    @edit.insertItem(i18n("&Paste"),Paste,-1)
    @edit.setAccel(Qt::CTRL+Key_P,Paste)

    @edit.insertSeparator
    @edit.insertItem(i18n("&Find"),Search,-1)
    @edit.setAccel(Qt::CTRL+Key_F,Search)

    @edit.insertItem(i18n("Find a&gain"),SearchAgain,-1)
    @edit.setAccel(Qt::CTRL+Key_G,SearchAgain)

    @edit.insertItem(i18n("&Replace"),Replace,-1)
    @edit.setAccel(Qt::CTRL+Key_R,Replace)

    @edit.insertItem(i18n("&Go to line..."),GoToLine,-1)
    @edit.setAccel(Qt::CTRL+Key_G,GoToLine)

    @edit.insertSeparator

    @edit.insertItem(i18n("Select &all"),SelectAll, -1)
    @edit.setAccel(Qt::CTRL+Key_A,SelectAll)

    @option = QPopupMenu.new
    menuBar.insertItem(i18n( "&Option"),@option)
    @optionSub = QPopupMenu.new
    @option.insertItemQPopupMenu(i18n("&Color"),@optionSub)
    @optionSub.insertItem(i18n("Set &foreground color"),SetForegroundColor)
    @option.setAccel(Qt::CTRL+Key_F,SetForegroundColor)
    @optionSub.insertItem(i18n("Set &background color"),SetBackgroundColor)
    @option.setAccel(Qt::CTRL+Key_B,SetBackgroundColor)
    @optionFont = QPopupMenu.new
    @option.insertItemQPopupMenu(i18n("Set font"),@optionFont)
    @optionFont.insertItem(i18n("Select font"),SetFont)
    @optionFont.insertItem(i18n("Set fixed font"),SetFixedFont)
    @option.insertSeparator
    @option.insertItem(i18n("Spell Check"),Spellcheck)
    @option.insertItem(i18n("Spell Check Configure"),SpellcheckConfig)

    @controls = QPopupMenu.new
    menuBar.insertItem(i18n( "&Controls"), @controls )

    #@mb = @controls.insertItem( "Menu bar", ToggleMenuBar,-1)
    #@controls.setAccel(ToggleMenuBar,Qt::CTRL+Key_M)
    #// Now an accelerator for when the menubar is invisible!
    #@a = QAccel.new(self)
    #@a.connectItem( @a.insertItem( CTRL+Key_M ), self, "toggleMenuBar" )

    @tb = @controls.insertItem(i18n( "Tool bar"), ToggleToolBar,-1)
    @controls.setAccel(ToggleToolBar, Qt::CTRL+Key_T)

    #@sb = @controls.insertItem( "Status bar", ToggleStatusBar, -1)
    #@controls.setAccel(ToggleStatusBar, Qt::CTRL+Key_B)
    @controls.setCheckable( true )
    #@controls.setItemChecked( @mb, true )
    @controls.setItemChecked( @tb, true )
    #@controls.setItemChecked( @sb, true )

    @help = QPopupMenu.new
    menuBar.insertSeparator
    menuBar.insertItem( i18n("&Help"), @help)
    @help.insertItem( i18n("&About Editor"), About)
    @help.insertItem( i18n("About &Qt"), AboutQt)

    @popup = QPopupMenu.new

    @popup.insertItem(i18n("Copy"),Copy,-1)
    @popup.insertItem(i18n("Cut"),Cut,-1)
    @popup.insertItem(i18n("Paste"),Paste,-1)
    Qt::connect(@popup,QSIGNAL("activated(int)"),self,"menuActivated")

    @e = REditWindow.new(KApplication::getKApplication, self, "editor" )
    @e.setPopup( @popup )
    #@e.setFocus
    setView( @e )
   @e.setStatusBar self.statusBar

   self.statusBar.setInsertOrder( KStatusBar::RightToLeft)
   self.statusBar.insertItem("line:000:col:000",ID_Pos)
   self.statusBar.insertItem("          ",ID_Message)
   @foregroundColor = QColor("black")
   @backgroundColor = QColor("white")
   set_color
    self.statusBar.changeItem( i18n("Ready"), ID_Message )
#    self.statusBar.changeItem("",ID_Message)
#    self.statusBar.message(i18n("Ready"),2000)
   @e.setFocus
   @e.showCursorPosition
    #catchEvent
end

def menuActivated id
   case id
   when NewDoc
      newDoc
   when Open
      load
   when Save
      save
   when SaveAs
      saveAs
   when Print
      printIt
   when Close
      closeDoc
   when Copy
      copy
   when Cut
      cut
   when Paste
      paste
   when Search
      search
   when SearchAgain
      searchAgain
   when Replace
      replace
   when GoToLine
      goToLine
   when SelectAll
      selectAll
   when SetForegroundColor
      color  = KColorDialog::getColor(QColor("black"))
      @foregroundColor = color[1]
      set_color
   when SetBackgroundColor
      color = KColorDialog::getColor(QColor("white") )
      @backgroundColor = color[1]
      set_color
   when SetFont
      @e.selectFont()
   when SetFixedFont
      @e.setFont(QFont.new("fixed"))
   when Spellcheck
       spellcheck
   when SpellcheckConfig
       spellcheckConfig
   when ToggleMenuBar
      toggleMenuBar
   when ToggleToolBar
      toggleToolBar
   when ToggleStatusBar
      toggleStatusBar
   when About
      about
   when AboutQt
      aboutQt
   when Quit
      QApplication::qApp.quit
   end
end


def newDoc
    ed = REditorWindow.new
    ed.resize( 400, 200 )
    ed.show
end

def load
    fd = QFileDialog.new(".","*.txt",nil,"fd",true)
    fd.setMode( QFileDialog::ExistingFile )
    ql =QStrList.new
    ql.append("*.txt")
    ql.append("*.rb")
    ql.append("*.*")

    fd.setFiltersQStrList(ql)
    fd.show
    fn = fd.selectedFile
    if ( !fn.isEmpty() )
        fname = fn.to_str
	loadFile( fname )
    else
	self.statusBar.message( i18n("Loading aborted"), 2000 )
    end
end


def loadFile fn
    @filename = fn
    f = File::open( @filename,"r")
    @e.clear
    @e.setAutoUpdate( false )
    while (!f.eof?)
      s = f.gets
      s.chop!
      s = Kconv::toeuc(s)
      @e.append(s)
    end
    f.close

    @e.setAutoUpdate( true )
    @e.repaintAll
    setCaption( @filename )

    s =  i18n("Loaded document:") + " #{@filename} "
    self.statusBar.message( s, 2000 )
end


def save
    if (@filename == nil )
      @filename = "NewFile"
      qfilename = QFileDialog:: getSaveFileName(@filename,"*.txt",self)
      if( !qfilename.isEmpty )
         @filename = qfilename.to_str
      end
    end
    contents = @e.text
    str = contents.to_str
    f = File::open(@filename,"w+")
    f.puts str
    f.close

    s = i18n("Save document to") + " #{@filename} "
    self.statusBar.message(s, 2000)

end

def saveAs
    @filename = "NewFile"
    qfilename = QFileDialog:: getSaveFileName(@filename,"*.txt",self)
    if( !qfilename.isEmpty )
       @filename = qfilename.to_str
    end

    contents = @e.text
    str = contents.to_str
    f = File::open(@filename,"w+")
    f.puts str
    f.close
    setCaption( @filename )

    s = i18n("Save document to") + " #{@filename}"
    self.statusBar.message(s, 2000)

end

def printIt

    @pageNo = 1

    if ( @printer.setup(self) ) 		#// printer dialog
	self.statusBar.message( i18n("Printing...") ,4000)
	p = QPainter.new(nil)
	p.begin( @printer )			#// paint on printer
	p.setFont( @e.font )
	yPos        = 0			 	#// y position for each line
	fm = p.fontMetrics
	metrics = QPaintDeviceMetrics.new( @printer )	 #// need width/height
	                                         	#// of printer surface
	for i in 0..(@e.numLines - 1)
	    if ( MARGIN + yPos > metrics.height - MARGIN )
                @pageNo = @pageNo + 1
		msg = i18n("Printing (page") + " #{@pageNo})..."
		self.statusBar.message( msg ,4000)
		@printer.newPage		#// no more room on this page
		yPos = 0			#// back to top of page
	    end
	    p.drawTextXYWH( MARGIN, MARGIN + yPos,
			metrics.width, fm.lineSpacing,
			ExpandTabs || DontClip,
			@e.textLine( i ) )
	    yPos = yPos + fm.lineSpacing
	end
	p.end				#// send job to printer
	self.statusBar.message( i18n("Printing completed"), 2000 )
    else
	self.statusBar.message( i18n("Printing aborted"), 2000 )
    end

end

def closeDoc

    close( true )	#// close AND DELETE!
end

def copy
   @e.copyText
end

def cut
   @e.cut
end

def paste
   @e.paste
end

def search
    @e.Search
end

def searchAgain
    @e.repeatSearch
end

def goToLine
    @e.doGotoLine
end

def replace
    @e.Replace
end

def selectAll
   @e.selectAll
end

def gotoLine linNum
   @e.setCursorPosition(linNum,0)
   @e.setFocus
   @e.showCursorPosition
end

def toggleMenuBar

    if ( menuBar.isVisible )
	menuBar.hide
	@controls.setItemChecked( @mb, false )
    else
	menuBar.show
	@controls.setItemChecked( @mb, true )
    end

end

def toggleToolBar

    if ( @fileTools.isVisible )
#	@fileTools.hide
	@controls.setItemChecked( @tb, false )
    else
#	@fileTools.show
	@controls.setItemChecked( @tb, true )
    end
    enableToolBar
end

def toggleStatusBar

    if ( self.statusBar.isVisible )
	self.statusBar.hide
	@controls.setItemChecked( @sb, false )
    else
	self.statusBar.show
	@controls.setItemChecked( @sb, true )
    end
    enableStatusBar
end
def set_color
   mypalette = @e.palette.copy
   cgrp = mypalette.normal
   b = QColor("black")
   ncgrp = QColorGroup.new(@foregroundColor, cgrp.background, cgrp.light, cgrp.dark ,cgrp.mid, @foregroundColor, @backgroundColor)
   mypalette.setNormal( ncgrp )
   mypalette.setDisabled(ncgrp)
   mypalette.setActive(ncgrp)

   @e.setPalette(mypalette)
   @e.setBackgroundColor(@backgroundColor)
end

def spellcheck
   @e.spellcheck
end

def spellcheckConfig
   #kwm = KWM.new
   qtd = QTabDialog.new(self,"tabdialog",true)
   qtd.setCaption(i18n("Spellchecker Options"))

  ksc =  KSpellConfig.new(qtd, "", @e.ksConfig)
  qtd.addTab (ksc, "Spellchecker")
  qtd.setCancelButton ()

  #//  qtd.resize (ksc.sizeHint().width(), ksc.sizeHint().height());
  #kwm.setMiniIcon (qtd.winId, kapp.getMiniIcon)

  if (qtd.exec != 0)

      ksc.writeGlobalSettings()
      @e.setKSConfig (ksc)
    end

end

def about

  QMessageBox::informationOK( self, i18n("About Ruby/KDE Editor"),
			i18n("This is a simple editor for ruby/KDE\n") + "(C) 2000 for Ruby/Kde by Nobuyuki Horie\n horie@smail.u-shizuoka-ken.ac.jp")
end


def aboutQt

  QMessageBox::aboutQt( self, i18n("About Qt") )
end

end

